/*
 * Copyright (c) 2010 by Intevation GmbH
 *
 * This program is free software under the LGPL (>=v2.1)
 * Read the file LGPL.txt coming with the software for details
 * or visit http://www.gnu.org/licenses/ if it does not exist.
 */

/**
 * Title:           Statistics, $Header: /share/gdi/SDI-Suite/Repository/projekte/BSH-GDI/genericViewer/src/main/java/de/conterra/bsh/gdi/gnviewer/output/statistics/Statistics.java,v 1.2 2008/01/30 12:38:34 blume Exp $
 * Source:          $Source: /share/gdi/SDI-Suite/Repository/projekte/BSH-GDI/genericViewer/src/main/java/de/conterra/bsh/gdi/gnviewer/output/statistics/Statistics.java,v $
 * created by:      Stefan Blume (blume)
 * erstellt am:     14.12.2007
 * Copyright:       con terra GmbH, 2005
 *
 * modified by:     $Author: blume $
 * modified on:     $Date: 2008/01/30 12:38:34 $
 * Version:         $Revision: 1.2 $
 * TAG:             $Name:  $
 * locked from:     $Locker:  $
 * CVS State:       $State: Exp $
 * Project:         $ProjectName$
 */
package de.intevation.gnv.statistics;

import de.intevation.gnv.state.describedata.KeyValueDescibeData;

import de.intevation.gnv.statistics.exception.StatisticsException;

import java.util.Collection;

/**
 * This interface defines one single method to calculate a statistic for a
 * given data set.
 *
 * @author blume
 */
public interface Statistics {

   /**
    * This method takes a data set and creates a statistic from it.
    *
    * @param resultSet The resulting statistic is about this data set.
    * @param parameters A collection of parameters.
    * @param measurements A collection of measurements.
    * @param dates A collection of dates.
    * @return a collection of statistics.
    * @throws StatisticsException if an error occured while creating the
    * statistic.
    */
    public Collection<StatisticSet>  calculateStatistics(
         Object                          resultSet,
         Collection<KeyValueDescibeData> parameters,
         Collection<KeyValueDescibeData> measurements,
         Collection<KeyValueDescibeData> dates
    )
    throws StatisticsException;
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
